<template>
  <CCardBody>
    <template>
      <CSelect
        addInputClasses="customChevron"
        label="Склад автозаказа"
        :options="warehouses"
        :value.sync="wbStorage.warehouseId"
        :invalidFeedback="invalidWarehouseIdMessage"
        :isValid="isInvalidWarehouseId"
      />
      <CSelect
        addInputClasses="customChevron"
        label="Склад реализации WB"
        :options="wbRealizationWarehouses"
        :value.sync="wbStorage.wbRealizationWarehouseId"
        :invalidFeedback="invalidWbRealizationWarehouseIdMessage"
        :isValid="isInvalidWbRealizationWarehouseId"
      />
      <CSelect
        addInputClasses="customChevron"
        label="Склад остатков WB"
        :options="wbRemainWarehouses"
        :value.sync="wbStorage.wbRemainWarehouseId"
        :invalidFeedback="invalidWbRemainWarehouseIdMessage"
        :isValid="isInvalidWbRemainWarehouseId"
      />
      <div class="controlButton">
        <CButton
          color="danger"
          class="cancel mr-2"
          @click="onClose(false)"
        >
          Отмена
        </CButton>
        <CButton
          color="primary"
          class="save"
          @click="onClose(true)"
        >
          Сохранить
        </CButton>
      </div>
    </template>
  </CCardBody>
</template>

<script>
  import {mapGetters, mapActions} from 'vuex';
  import fieldWarnings from "../../../../../constants/fieldWarnings";

  export default {
    name: "EditingWbStorage",
    props: {
      wbStorageInfo: {
        // Информация о редактируемой строке таблицы
        type: Object,
        default() {
          return {};
        },
      },
    },
    data() {
      return {
        wbStorage: {},
        wbStorageCopy: {},
        warnings: {},
        defaultWarnings: {},
      }
    },
    computed: {
      isInvalidWarehouseId() {
        return 'warehouseId' in this.warnings ? false : null;
      },
      invalidWarehouseIdMessage() {
        return this.isInvalidWarehouseId === false ? this.warnings.warehouseId : '';
      },
      isInvalidWbRealizationWarehouseId() {
        return 'wbRealizationWarehouseId' in this.warnings ? false : null;
      },
      invalidWbRealizationWarehouseIdMessage() {
        return this.isInvalidWbRealizationWarehouseId === false ? this.warnings.wbRealizationWarehouseId : '';
      },
      isInvalidWbRemainWarehouseId() {
        return 'wbRemainWarehouseId' in this.warnings ? false : null;
      },
      invalidWbRemainWarehouseIdMessage() {
        return this.isInvalidWbRemainWarehouseId === false ? this.warnings.wbRemainWarehouseId : '';
      },
      ...mapGetters(['wbRealizationWarehouses', 'wbRemainWarehouses', 'warehouses']),
    },
    watch: {
      'wbStorage.warehouseId'(warehouseId) {
        const {message} = this.defaultWarnings.warehouseId;
        this.checkFieldValidation('warehouseId', warehouseId, message);
      },
      'wbStorage.wbRealizationWarehouseId'(wbRealizationWarehouseId) {
        const {message} = this.defaultWarnings.wbRealizationWarehouseId;
        this.checkFieldValidation('wbRealizationWarehouseId', wbRealizationWarehouseId, message);
      },
      'wbStorage.wbRemainWarehouseId'(wbRemainWarehouseId) {
        const {message} = this.defaultWarnings.wbRemainWarehouseId;
        this.checkFieldValidation('wbRemainWarehouseId', wbRemainWarehouseId, message);
      },
      wbRealizationWarehouses(wbRealizationWarehouses) {
        // Установка значения поля "Склад реализации wb" в случае, если оно не задано
        if (!this.wbStorage.wbRealizationWarehouseId && wbRealizationWarehouses.length) {
          this.wbStorage.wbRealizationWarehouseId = wbRealizationWarehouses[0].value;
        }
      },
      wbRemainWarehouses(wbRemainWarehouses) {
        // Установка значения поля "Склад остатков wb" в случае, если оно не задано
        if (!this.wbStorage.wbRemainWarehouseId && wbRemainWarehouses.length) {
          this.wbStorage.wbRemainWarehouseId = wbRemainWarehouses[0].value;
        }
      },
    },
    created() {
      this.setDefaultData();
      this.setDefaultWarnings();
      this.getWbWarehouses();
    },
    methods: {
      setDefaultData() {
        // Установка полученных из Props значений для последующего их редактирвоаня
        const {warehouse_id, wb_realization_warehouse_id, wb_remain_warehouse_id} = this.wbStorageInfo;
        let wbRealizationWarehouseId = +wb_realization_warehouse_id
        if (!wb_realization_warehouse_id && this.wbRealizationWarehouses.length) {
          wbRealizationWarehouseId = this.wbRealizationWarehouses[0].value;
        }
        let wbRemainWarehouseId = +wb_remain_warehouse_id;
        if (!wb_remain_warehouse_id && this.wbRemainWarehouses.length) {
          wbRemainWarehouseId = this.wbRemainWarehouses[0].value;
        }
        let warehouseId = +warehouse_id;
        if (!this.warehouses.length) {
          warehouseId = '';
        }
        this.wbStorage = {
          warehouseId,
          wbRealizationWarehouseId,
          wbRemainWarehouseId,
        };
      },
      onClose(closeType) {
        if (closeType) {
          if (this.checkValidation()) {
            this.$emit('onClose', {closeType, data: this.wbStorage});
          }
        } else {
          this.$emit('onClose', {closeType});
        }
      },
      checkValidation() {
        // Проверка корректности данных в полях
        return Object.keys(this.warnings).length === 0;
      },
      checkFieldValidation(
        field, value, warningMessage, compareFunc,
      ) {
        // Проверка поля на валидность
        // field String - название поля
        // value String - значение поля
        // warningMessage String - Текст, показываемый если поле не прошло валидацию
        // compareFunc Function - Функция валидирования поля
        const compareResult = compareFunc ? compareFunc(value) : defaultCompare(value);
        if (compareResult) {
          if (field in this.warnings) {
            this.warnings[field] = compareResult;
          } else {
            this.$set(this.warnings, field, compareResult);
          }
        } else if (field in this.warnings) {
          this.$delete(this.warnings, field);
        }

        function defaultCompare(value) {
          return value === '' ? warningMessage : false;
        }
      },
      setDefaultWarnings() {
        // Установка ошибок по умолчанию
        this.defaultWarnings = {
          warehouseId: {message: fieldWarnings.emptyField},
          wbRealizationWarehouseId: {message: fieldWarnings.emptyField},
          wbRemainWarehouseId: {message: fieldWarnings.emptyField},
        }
      },
      getWbWarehouses() {
        // Полечение данных для селектбоксов
        if (!this.wbRealizationWarehouses.length) {
          this.getWbRealizations()
            .catch(() => {
              this.wbStorage.wbRealizationWarehouseId = '';
            });
        }
        if (!this.wbRemainWarehouses.length) {
          this.getWbRemains()
            .catch(() => {
              this.wbStorage.wbRemainWarehouseId = '';
            });
        }
      },
      ...mapActions(['getWbRealizations', 'getWbRemains']),
    },
  }
</script>
